package ru.dbotthepony.mc.otm.menu.matter

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.block.entity.matter.ItemRepairerBlockEntity
import ru.dbotthepony.mc.otm.capability.matter.matter
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.MatterySlot
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class ItemRepairerMenu(
	containerId: Int,
	inventory: Inventory,
	tile: ItemRepairerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.ITEM_REPAIER, containerId, inventory, tile) {
	val matterWidget = LevelGaugeWidget(this, tile?.matter)
	val slot = object : MatterySlot(tile?.repairContainer ?: SimpleContainer(1), 0) {
		override fun mayPlace(itemStack: ItemStack): Boolean {
			return itemStack.isRepairable && itemStack.isDamaged && super.mayPlace(itemStack)
		}
	}

	init {
		addStorageSlot(slot)
		addInventorySlots()
	}
}
